#!/usr/bin/perl -w
# /usr/local/httpd/cgi-bin/formzugang.cgi
# Autor: Dr. Dieter Heimann, Robert-Bosch-Berufskolleg, Dortmund
# letzte nderung: 10. Maerz  2001
#
# Formular zum Aussperren einzelner Rechner
# die ausgewhlten Rechner erhalten keinen Zugang
 zum Proxy
#
# Ergaenzung: 
# die Datei squid.sperren_raum wird aus der aktuellen 
# Datei dhcpd.leases erzeugt
# Gisbert Friege, 28.6.2002
# gfriege@t-online.de
#
# Anzeige der Anmeldungen; 
#
use CGI qw(:standard);
#
# Beginn Standardkonfiguration
# Proxy-Port
$server_port = 3128;

# Auswahl des Verfahrens: Kernelversionen 2.0 und 2.2 fr Firewall moeglich
# 1.0 waehlt den Proxy
$kernelver="1.0";

# Datei mit den Arbeitsplaetzen
$plaetze="/etc/httpd/ipfw_http";

# Steuerdatei von Squid
$squidfile="/etc/squid.sperren_ip";

# Hintergrund des Formulars
$background="";
$cgipath="/cgi-bin/";
# Ende Standardkonfiguration
# Konfigurationsdatei, falls vorhanden auswerten
sub get_param
# Zeichenkette zwischen " " auswaehlen
{
 $temp = substr($_[0],index($_[0],"\"")+1);
 $temp = substr($temp,0,index($temp,"\""));
 return $temp;
}
if (open(CONF,"/etc/zugang.conf"))
{
 while (<CONF>)
 {
# alle Kommentarzeilen nicht bearbeiten
  unless (/^#/)
  {
   if (/kernelver/) { $kernelver = &get_param($_) }
   if (/server_port/) { $server_port = &get_param($_) }
   if (/plaetze/)   { $plaetze = &get_param($_) }
   if (/leases/)   { $leases = &get_param($_) }
   if (/raeume/)   { $raeume = &get_param($_) }
   if (/squidfile/) { $squidfile = &get_param($_) }
   if (/background/) { $background = &get_param($_) }
   if (/cgipath/)   { $cgipath = &get_param($_) }
  }
 }
}
# Konfigurationsdatei ausgewertet

$remoteip=$ENV{'REMOTE_ADDR'};
#zum Test am eigenen Rechner, sonst auskommentieren
#$remoteip="192.168.3.21";

$remoteraum="Raum ???";
$remotepc="??";
$alle_raeume = "nein";
if (param("alle"))
{
  $alle_raeume = param("alle");
}
print "Content-type: text/html\n\n";
print "<HTML>\n";
print "<HEAD>\n";
print "<TITLE>Sperrung des Internet-Zuganges</TITLE>\n";
print '<meta http-equiv="expires" content="0">';
print "<script language=\"JavaScript\">\n<!-- \n";
print "function Auswahl(raum, wert) \n{\n switch(raum)\n{";

############### Beginn Zusatz von Gisbert Friege

# Einlesen der leases.dhcpd in den Hash %paare
open(LDAT,"< $leases") || die "\nKann Leasesdatei $LDATEI nicht oeffnen\n";
%paare = ();
while (<LDAT>) {
    if (not ($_=~ /#/) and (($_=~ /lea/) or ($_=~ /cli/)))  {
	if (/^lease\s(.*)\s{.*/) {
	$ip = $1 ;
	}
	elsif (/.*name\s"(.*)".*;/) {
	$paare{$1} = $ip;
	}
    }
}
close(LDAT);

# Raeume werden eingelesen in den Array @raumarray
open(RDAT,"< $raeume") || die "\nKann Raeumedatei $raeume nicht oeffnen\n";
@raumarray = ();
while (<RDAT>){
    chomp($_);
    push (@raumarray,$_);
}
close(RDAT);

# jetzt Ausgabe...
 
open(AUSDAT,"> $plaetze") || die "\nKann Ausgabedatei $plaetze nicht oeffnen\n";
# ... erstmal die fuer die Raeume
foreach (@raumarray) { 
    printf AUSDAT "Raum $_\n"; 
    foreach $key (sort(keys %paare)) {
	if ((index $key, $_) == 0) {
	$wert = $paare{$key};
	printf AUSDAT "$key $wert\n";
	}
    }	
}

# ... und jetzt den Rest
print AUSDAT "Raum ANDERE\n";
foreach $key (sort(keys %paare)) {
	$passt = 0;
	foreach (@raumarray) {
	    if ((index $key, $_) == 0) {
	    $passt = 1;
	    }
	}    
	if ($passt != 1){
	    $wert = $paare{$key};
	    printf AUSDAT "$key $wert\n";
	}
}

close(AUSDAT);


############### Ende Zusatz von Gisbert Friege

open (INFILE, "<$plaetze") || print "Kann die Datei $plaetze nicht ffnen!<BR>";
@adressen = <INFILE>;
close (INFILE);
$anzahl = @adressen;
 
# Datei bearbeiten
$first = 1;
for ($i=0; $i<$anzahl; $i++)
{
   $adr = substr($adressen[$i],0,length($adressen[$i])-1);
   if ($adr !~ /^#/)
    {
     if ($adr =~ /^Raum/)
      {
        if ($first == 0)
        {
          print "break; \n";
        }
        print "case \"$adr\":\n";
        $raum = $adr;
      }
     else
      {
       $first = 0;
       $pc = substr($adr,0,index($adr," "));
       $ip = substr($adr,index($adr," ")+1);
       if ($ip eq $remoteip)
       {
         $remoteraum = $raum;
         $remotepc = $pc;
       }
       $pc =~ s/-/_/g;
       print "document.formular.$pc.checked = wert;\n";
      }
     }
}
print 'break;}}//--></script>';
print "</HEAD>\n";
print "<BODY background=\"$background\" bgcolor=\"#CCCCCC\" text=\"#000000\" >";
print "\n<CENTER>\n";
print "<H1>Sperrung des Internet-Zuganges</H1>\n";
print "</CENTER>\n";
print "<H4>W&auml;hlen Sie die Arbeitspl&auml;tze aus, deren Zugangsberechtigung Sie ver&auml;ndern m&ouml;chten. Grunds&auml;tzlich k&ouml;nnen nur hier eingetragene Rechner freigegeben werden!</H4>";
print "<H4>Das Formular zeigt den aktuellen Status an. ";
print "Gesperrte Arbeitspl&auml;tze sind <font color=\"#FF0000\">rot</font> markiert.</H4> ";
print "Hinweis: Die &Auml;nderungen werden erst nach dem <a HREF=\"#unten\">Abschicken</a> des Formulars aktiv.<BR>";
print "Zu jedem Arbeitsplatz wird der angemeldete Benutzer angegeben!";
print "<H3>Ihr Arbeitsplatz: $remotepc <small>($remoteip)</small> in $remoteraum</H3>\n";
# alle Raeume
if ($alle_raeume eq "ja")
{
 print "<H3>Eingetragene R&auml;ume</H3>\n";
 print '<BLOCKQUOTE><TABLE border="0" cellpadding="2" width="90%"><TR>';
 $spalte = 0;
 for ($i=0; $i<$anzahl; $i++)
 {
   $adr = substr($adressen[$i],0,length($adressen[$i])-1);
   if ($adr !~ /^#/)
    {
     if ($adr =~ /^Raum/)
      {
        $spalte++;
        if ($spalte > 3)
        {
          $spalte=1;
          print "</TR><TR>";
        }
        print "<TD><H3><a href=\"#$adr\">$adr</a></H3></TD>\n";
      }
     }
 }
 print "</TR></TABLE></BLOCKQUOTE><HR>";
}
# Ende alle Raeume

# hier beginnt das Formular
$action = join($cgipath,"internet.cgi");
print "<FORM NAME=\"formular\" ACTION=\"$action\" METHOD=\"POST\">","\n";
#
# Raeume und Arbeitsplaetze aus der Datei auslesen

open (INFILE, "<$plaetze") || print "Kann die Datei $plaetze nicht ffnen!<BR>";
@adressen = <INFILE>;
close (INFILE);
$anzahl = @adressen;

# Datei bearbeiten
# Inhaltverzeichnis
print "<input type=\"hidden\" name=\"kontrolle\" value=\"zugang\"\n";
# aktuellen Status bestimmen
if ($kernelver eq "2.2")
{
   @status = `log/ipchains -L input -n | grep $server_port`;
}
elsif ($kernelver eq "2.0")
{
  @status = `log/ipfwadm -I -l -n | grep $server_port`
}
else
{
  open (INFILE, "<$squidfile") || print "Kann die Datei $squidfile nicht ffnen! <br>";
  @status = <INFILE>;
  close (INFILE);
}
$zeilen = @status;
print '<BLOCKQUOTE><TABLE border="0" cellpadding="2" width="90%"><TR>';
$spalte = 0;
$gefunden = 0;

for ($i=0; $i<$anzahl; $i++)
{
   $adr = substr($adressen[$i],0,length($adressen[$i])-1); 
   if ($adr !~ /^#/)
    {
     if ($adr =~ /^Raum/)
      {
        if ($adr eq $remoteraum || $alle_raeume eq "ja" )
        {
          $gefunden=1;
          $spalte=0;
          print "</TR><TD valign=\"top\"></BLOCKQUOTE><BR><H3><a name=\"$adr\">$adr</a></H3><BLOCKQUOTE></TD><TD valign=\"middle\">\n";
          print "Raum <input type=\"button\" value=\"sperren\" name=\"$adr\" onClick=\"Auswahl('$adr',true)\">";
          print " / <input type=\"button\" value=\"freigeben\" name=\"$adr\"";
          print "onClick=\"Auswahl('$adr',false)\"></TD><TR>\n";
        }
       else
        {
         $gefunden = 0;
        }
      }
     else
      {
       $pc = substr($adr,0,index($adr," "));       
       $ip = substr($adr,index($adr," ")+1);
       $k = 0;
       $checked = 0;
       while ($k < $zeilen)
       {
      #  print "$status[$k] ";
        if ($status[$k] =~ /$ip(\s|\/)/s)
         {
          $k = $zeilen;
          $checked = 1;
         }
         $k++;
       }
       if ($gefunden == 1)
       {
        $spalte++;
        if ($spalte > 3)
        {
         $spalte = 1;
         print "</TR><TR>";
        }
         $pcname = $pc;
         $pcname =~ s/-/_/g;
         print "<TD valign=\"top\"><input type=\"checkbox\" name=\"$pcname\" ";
       if (! $checked)
       {
          print "checked "; 
       }
       print "value=\"$pcname\"><strong>";
       if (! $checked)
        {
         print "<font color=\"#FF0000\">$pc</font>";
        }
       else
        {
         print "$pc";
        }
       if (open (INFILE, "<log/$ip"))
       {
         while (<INFILE>)
         {
           $anmeldung = $_;
         }
         close(INFILE);
       }
       else
       {
        $anmeldung = "";
       }
       print "</strong> <small>($ip)</small>$anmeldung";
       print "</TD>\n";
      }  # gefunden == 1
     else
      {
       print "<input type=\"hidden\" name=\"$pc\" ";
       if (! $checked)
       {
         print "value=\"no_change\">\n"; 
       }
       else
       {
         print "value=\"no_change\">\n";
       }
      }
    }
    }	
}
print "</TR></TABLE>";

print "<BR>";
# Formularaktionen
print '<INPUT TYPE="submit" NAME="sperren" VALUE="&Auml;nderungen durchf&uuml;hren">';
print "   <a name=\"unten\"</a>";
print "<INPUT TYPE=\"reset\" VALUE=\"Anfangszustand\">";
print "<BR>\n";
print "</FORM></BLOCKQUOTE>";
# hier endet das Formular

print <<Begin;
<BR><strong>Hinweis:</strong> <BR><BLOCKQUOTE>
<UL><LI>Bitte sperren Sie nur die Arbeitspl&auml;tze
in Ihrem Klassenraum.</LI>
<LI>Ihre durchgef&uuml;hrten &Auml;nderungen werden in einer Protokolldatei festgehalten.</LI>
<LI>Falls Sie noch keine Berechtigung besitzen, wenden Sie sich bitte an Ihren Netzwerkadministrator.</LI>
</LU></BLOCKQUOTE></BLOCKQUOTE>
Begin
# hier beginnt das Seitenende
print "<HR>";
print "<table border=\"0\" cellpadding=\"2\" width=\"100%\" >";
print "<TR><TD>";
print '<small><small>Autor: <a href="mailto:Dieter.Heimann@T-Online.de">Dr. Heimann</a> </small></small></TD>';
print "<TD> <p align=\"right\"><small><small>Februar 2001</small></small></p></TD>\n"; 
print "</TABLE></BODY>";
print "</HTML>";
